using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using BandObjectLib;
using System.Diagnostics;
using System.Runtime.InteropServices;

namespace MasterSearchToolbar
{
    [Guid("320E9AA2-67E5-4ee3-9459-C1D9E9A8BE6E")]
    [BandObject("MasterSearch Toolbar",
    BandObjectStyle.Horizontal | BandObjectStyle.TaskbarToolBar,
    HelpText = "Toolbar for MasterSearch.co.nr")]
    
    public partial class Toolbar : BandObject
    {
        private string[] symbols ={ "$", "&", "+", ",", "/", ":", ";", "=", "?", "@", " ", "\"", "<", ">", "#", "%", "{", "}", "|", "\\", "^", "~", "[", "]", "`" };

        private string[] values ={ "%24", "%26", "%2B", "%2C", "%2F", "%3A", "%3B", "%3D", "%3F", "%40", "%20", "%22", "%3C", "%3E", "%23", "%25", "%7B", "%7D", "%7C", "%5C", "%5E", "%7E", "%5B", "%5D", "%60" };

        public Toolbar()
        {
            InitializeComponent();
        }
        private void GoToURL() {

            Process p = new Process();
            p.StartInfo.FileName = "http://sumitmehta.x10hosting.com/search/go.php?q=" + URLEncode(textBox1.Text);
            p.Start();
        }
        public string URLEncode(string url) {

            StringBuilder b = new StringBuilder();

            for (int i = 0; i < url.Length; i++) {

               if (isInvalidChar(url.Substring(i, 1)))
                        b.Append(values[getIndex(url.Substring(i, 1))]);
                    else
                        b.Append(url.Substring(i, 1));
                }
            return b.ToString();
        }
        public bool isInvalidChar(string q) {

            bool r = false;

            for (int j = 0; j < symbols.Length; j++) {

                if (symbols[j] == q)
                    r = true;
            }
            return r;
        }
        public int getIndex(string q)
        {

            int r = 0;

            for (int j = 0; j < symbols.Length; j++)
            {

                if (symbols[j] == q)
                    r = j;
            }
            return r;
        }
        private void label1_Click(object sender, EventArgs e)
        {
            submitQuery();
        }
        private void textBox1_KeyDown(object sender, KeyEventArgs e) {

            if (e.KeyValue == 13)
                submitQuery();
        }
        private void label1_MouseEnter(object sender, EventArgs e)
        {
            label1.ForeColor = System.Drawing.SystemColors.Highlight;
        }
        private void label1_MouseLeave(object sender, EventArgs e)
        {
            label1.ForeColor = System.Drawing.SystemColors.Info;
        }
        private void submitQuery() {

            if (textBox1.Text.Equals(""))
            {
                MessageBox.Show("Please enter some text to search.", "Empty Field", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
                GoToURL();
        }
    }
}
